## Use this script only for CASE 3, where all antennas have ALT-AZ mounts and the parallactic angle correction is NOT applied.
import numpy as np
import pylab as pl
import os, sys
import glob
import pickle as pk

MSNAME = 'POLSIM_CASE-33_for_PolCal.ms'


## Run polcal and generate Dterm table:
os.system('rm -rf polcal.Dterms')
polcal(vis = MSNAME, caltable = 'polcal.Dterms')



## READ FITTED DTERMS:
tb.open('polcal.Dterms')
DTS = tb.getcol('CPARAM')
tb.close()



## RECOVER THE SIMULATED DTERMS:
INFILE = open('POLSIM_CASE-33_Dterms.dat','rb')
DRs,DLs = pk.load(INFILE) ; INFILE.close()




#### PLOT FITTED vs. TRUE DTERM COMPARISON:
fig = pl.figure()
sub = fig.add_subplot(111)
for ant in range(8):
  sub.plot(DRs.real,DTS[0,0,:].real,'or')
  sub.plot(DRs.imag,DTS[0,0,:].imag,'^r')
  sub.plot(DLs.real,DTS[1,0,:].real,'ob')
  sub.plot(DLs.imag,DTS[1,0,:].imag,'^b')

sub.plot([],[],'or',label='DR Real')
sub.plot([],[],'^r',label='DR Imag')
sub.plot([],[],'ob',label='DL Real')
sub.plot([],[],'^b',label='DL Imag')
sub.plot(np.array([-0.5,0.5]),np.array([-0.5,0.5]),':k')
pl.legend(numpoints=1,loc=4)
pl.xlabel('True Dterms')
pl.ylabel('PolCal Dterms')
pl.suptitle('Point Source Calibrator')
pl.savefig('POLCAL_TEST.png')
pl.show()










